"use strict";

require("../../mocha-config");

var AddPluginDialog = require('../../../../main/js/gui/admin/AddPluginDialog');
var ServerConnector = require('../../ServerConnector-mock');
var ValidationError = require('../../../../main/js/ValidationError');


var logger = require('../../logger');

var fs = require("fs");
var chai = require('chai');
var assert = chai.assert;

describe('AddPluginDialog', function () {
  /**
   *
   * @returns {AddPluginDialog}
   */
  var createDialog = function () {
    return new AddPluginDialog({
      element: testDiv,
      customMap: null,
      configuration: helper.getConfiguration(),
      serverConnector: ServerConnector
    });
  };
  it('init', function () {
    helper.loginAsAdmin();
    var dialog = createDialog();
    return dialog.init().then(function () {
      assert.equal(0, logger.getWarnings().length);
      return dialog.destroy();
    });
  });
  describe('onSaveClicked', function () {
    it('without validation', function () {
      helper.loginAsAdmin();
      var dialog = createDialog();
      return dialog.init().then(function () {
        return dialog.onSaveClicked();
      }).then(function () {
        assert.notOk("error expected");
      }).catch(function () {
      }).finally(function () {
        return dialog.destroy();
      });
    });
    it('with validation', function () {
      helper.loginAsAdmin();
      var dialog = createDialog();
      return dialog.init().then(function () {
        $("[name='pluginUrl']").val("./testFiles/plugin/empty.js");
        return dialog.onValidateClicked();
      }).then(function () {
        return dialog.onSaveClicked();
      }).finally(function () {
        return dialog.destroy();
      });
    });
  });


})
;
